// B25Decoder.h: CB25Decoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_B25DECODER_H_)
#define _B25DECODER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IB25Decoder.h"
#include "MediaData.h"
#include "TsPacketParser.h"
#include "TsDescrambler.h"
#include "MediaGrabber.h"


class CB25Decoder : public IB25Decoder
{
public:
	CB25Decoder();
	virtual ~CB25Decoder();

// IB25Decoder
	const BOOL Initialize(DWORD dwRound = 4);
	void Release(void);

	const BOOL Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize);
	const BOOL Reset(void);

protected:
	static void CALLBACK OnPlainTsPacket(const CMediaData *pMediaData, const PVOID pParam);

	CTsPacketParser m_TsPacketParser;
	CTsDescrambler m_TsDescrambler;
	CMediaGrabber m_MediaGrabber;

	CMediaData m_InputBuff;
	CMediaData m_OutputBuff;
};

#endif // !defined(_B25DECODER_H_)
